"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; } function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }// src/index.ts
var _unplugincombine = require('unplugin-combine');
var _betterdefine = require('@vue-macros/better-define'); var _betterdefine2 = _interopRequireDefault(_betterdefine);
var _definemodel = require('@vue-macros/define-model'); var _definemodel2 = _interopRequireDefault(_definemodel);
var _unpluginvuedefineoptions = require('unplugin-vue-define-options'); var _unpluginvuedefineoptions2 = _interopRequireDefault(_unpluginvuedefineoptions);
var _defineprops = require('@vue-macros/define-props'); var _defineprops2 = _interopRequireDefault(_defineprops);
var _definerender = require('@vue-macros/define-render'); var _definerender2 = _interopRequireDefault(_definerender);
var _defineslots = require('@vue-macros/define-slots'); var _defineslots2 = _interopRequireDefault(_defineslots);
var _exportprops = require('@vue-macros/export-props'); var _exportprops2 = _interopRequireDefault(_exportprops);
var _hoiststatic = require('@vue-macros/hoist-static'); var _hoiststatic2 = _interopRequireDefault(_hoiststatic);
var _namedtemplate = require('@vue-macros/named-template'); var _namedtemplate2 = _interopRequireDefault(_namedtemplate);
var _reactivitytransformvue2 = require('@vue-macros/reactivity-transform-vue2'); var _reactivitytransformvue22 = _interopRequireDefault(_reactivitytransformvue2);
var _setupblock = require('@vue-macros/setup-block'); var _setupblock2 = _interopRequireDefault(_setupblock);
var _setupcomponent = require('@vue-macros/setup-component'); var _setupcomponent2 = _interopRequireDefault(_setupcomponent);
var _setupsfc = require('@vue-macros/setup-sfc'); var _setupsfc2 = _interopRequireDefault(_setupsfc);
var _shortemits = require('@vue-macros/short-emits'); var _shortemits2 = _interopRequireDefault(_shortemits);
var _common = require('@vue-macros/common');
function resolveOptions({
  root,
  version,
  plugins,
  isProduction,
  betterDefine,
  defineModel,
  defineOptions,
  defineProps,
  defineRender,
  defineSlots,
  exportProps,
  hoistStatic,
  namedTemplate,
  reactivityTransformVue2,
  setupBlock,
  setupComponent,
  setupSFC,
  shortEmits
}) {
  function resolveSubOptions(options, commonOptions = {}, defaultEnabled = true) {
    options = _nullishCoalesce(options, () => ( defaultEnabled));
    if (!options)
      return false;
    else if (options === true)
      return { ...commonOptions };
    else
      return { ...options, ...commonOptions };
  }
  root = root || process.cwd();
  version = version || _common.detectVueVersion.call(void 0, );
  isProduction = _nullishCoalesce(isProduction, () => ( process.env.NODE_ENV === "production"));
  return {
    plugins: plugins || {},
    betterDefine: resolveSubOptions(betterDefine, {
      isProduction
    }),
    defineModel: resolveSubOptions(defineModel, { version }),
    defineOptions: resolveSubOptions(defineOptions, {
      version
    }),
    defineProps: resolveSubOptions(defineProps, { version }),
    defineRender: resolveSubOptions(defineRender),
    defineSlots: resolveSubOptions(defineSlots, { version }),
    exportProps: resolveSubOptions(exportProps, { version }),
    hoistStatic: resolveSubOptions(hoistStatic),
    namedTemplate: resolveSubOptions(namedTemplate),
    reactivityTransformVue2: resolveSubOptions(
      reactivityTransformVue2,
      void 0,
      version === 2
    ),
    setupBlock: resolveSubOptions(setupBlock, void 0, false),
    setupComponent: resolveSubOptions(setupComponent, {
      root
    }),
    setupSFC: resolveSubOptions(setupSFC),
    shortEmits: resolveSubOptions(shortEmits)
  };
}
function resolvePlugin(unplugin, framework, options) {
  if (!options)
    return;
  return unplugin[framework](options);
}
var name = "unplugin-vue-macros";
var src_default = _unplugincombine.createCombinePlugin.call(void 0, (userOptions = {}, meta) => {
  const options = resolveOptions(userOptions);
  const framework = meta.framework;
  const setupComponentPlugins = resolvePlugin(
    _setupcomponent2.default,
    framework,
    options.setupComponent
  );
  const namedTemplatePlugins = resolvePlugin(
    _namedtemplate2.default,
    framework,
    options.namedTemplate
  );
  const plugins = [
    resolvePlugin(_setupsfc2.default, framework, options.setupSFC),
    setupComponentPlugins == null ? void 0 : setupComponentPlugins[0],
    resolvePlugin(_setupblock2.default, framework, options.setupBlock),
    resolvePlugin(_hoiststatic2.default, framework, options.hoistStatic),
    namedTemplatePlugins == null ? void 0 : namedTemplatePlugins[0],
    resolvePlugin(_defineprops2.default, framework, options.defineProps),
    resolvePlugin(_exportprops2.default, framework, options.exportProps),
    resolvePlugin(_shortemits2.default, framework, options.shortEmits),
    resolvePlugin(_definemodel2.default, framework, options.defineModel),
    resolvePlugin(_defineslots2.default, framework, options.defineSlots),
    resolvePlugin(
      _reactivitytransformvue22.default,
      framework,
      options.reactivityTransformVue2
    ),
    resolvePlugin(_betterdefine2.default, framework, options.betterDefine),
    resolvePlugin(_unpluginvuedefineoptions2.default, framework, options.defineOptions),
    options.plugins.vue,
    options.plugins.vueJsx,
    resolvePlugin(_definerender2.default, framework, options.defineRender),
    setupComponentPlugins == null ? void 0 : setupComponentPlugins[1],
    namedTemplatePlugins == null ? void 0 : namedTemplatePlugins[1]
  ].filter(Boolean);
  return {
    name,
    plugins
  };
});



exports.src_default = src_default;
