import * as unplugin_combine_types from 'unplugin-combine/types';
import { Options as Options$1 } from '@vue-macros/better-define';
import { Options as Options$2 } from '@vue-macros/define-model';
import { Options as Options$3 } from 'unplugin-vue-define-options';
import { Options as Options$4 } from '@vue-macros/define-props';
import { Options as Options$5 } from '@vue-macros/define-render';
import { Options as Options$6 } from '@vue-macros/define-slots';
import { Options as Options$7 } from '@vue-macros/export-props';
import { Options as Options$8 } from '@vue-macros/hoist-static';
import { Options as Options$9 } from '@vue-macros/named-template';
import { Options as Options$a } from '@vue-macros/reactivity-transform-vue2';
import { Options as Options$b } from '@vue-macros/setup-block';
import { Options as Options$c } from '@vue-macros/setup-component';
import { Options as Options$d } from '@vue-macros/setup-sfc';
import { Options as Options$e } from '@vue-macros/short-emits';

interface FeatureOptionsMap {
    betterDefine: Options$1;
    defineModel: Options$2;
    defineOptions: Options$3;
    defineProps: Options$4;
    defineRender: Options$5;
    defineSlots: Options$6;
    exportProps: Options$7;
    hoistStatic: Options$8;
    namedTemplate: Options$9;
    reactivityTransformVue2: Options$a;
    setupBlock: Options$b;
    setupComponent: Options$c;
    setupSFC: Options$d;
    shortEmits: Options$e;
}
type FeatureName = keyof FeatureOptionsMap;
type FeatureOptions = FeatureOptionsMap[FeatureName];
interface OptionsCommon {
    root?: string;
    version?: 2 | 3;
    isProduction?: boolean;
    plugins?: {
        vue?: any;
        vueJsx?: any;
    };
}
type OptionalSubOptions<T> = boolean | Omit<T, keyof OptionsCommon> | undefined;
type Options = OptionsCommon & {
    [K in FeatureName]?: OptionalSubOptions<FeatureOptionsMap[K]>;
};
type OptionsResolved = Pick<Required<OptionsCommon>, 'plugins'> & {
    [K in FeatureName]: false | FeatureOptionsMap[K];
};
declare const _default: unplugin_combine_types.UnpluginCombineInstance<Options>;

export { FeatureName, FeatureOptions, FeatureOptionsMap, Options, OptionsCommon, OptionsResolved, _default as default };
